TYPOS3.Flow - Bug # 28995

Status: Resolved Priority: Must have

Author: Sebastian Kurfuerst Category: Persistence
Created: 2011-08-16 Assigned To: Sebastian Kurfuerst
Updated: 2011-08-16 Due date:

PHP Version:

Has patch:

Complexity:

Affected Flow version:

Subject: Deferred Loading does not work with Doctrine QueryResult

Description

When looking into Doctrine\QueryResult, it becomes obvious that the rows are not lazily initialized on first access, but initialized all

the time. This is a severe performance penalty.

In #26862 the Doctrine Query was made serializable; but it was never accessed as the QueryResult was not lazy. This needs to be

fixed.

Related issues:
related to TYPOS.Flow - Bug # 26862: Doctrine\Query is not serializable Resolved
duplicated by TYPO3 Flow Base Distribution - Bug # 29045: Wakeup of Query set... Resolved

2011-05-17
2011-08-17

2011-05-18

Associated revisions

Revision 237b0ac7 - 2011-08-16 09:36 - Sebastian Kurfuerst

[BUGFIX] (Persistence): Implement deferred loading in Doctrine\QueryResult
Until now, Doctrine\QueryResult got all results passed into the constructor.

This change modifies the behavior such that queries are executed lazily, on first
access of the QueryResult object, leading to a big performance gain when dealing

with many objects.

Furthermore, cloned Query objects were still connected to the original instance,

as they shared the same QueryBuilder. This has been fixed as well.

Additionally, deserializing simple queries without a constraint now also works
properly. Before, this case lead to incomplete DQL, resulting in a Doctrine error.

All of the above is covered with Functional Tests.
Change-Id: Ide7faf982f68efe15eb2fdaa5¢68063b7770a735

Resolves: #28995

History

#1 - 2011-08-16 07:52 - Mr. Hudson
- Status changed from Accepted to Under Review

Patch set 1 of change |de7faf982f68efe15eb2fdaa5c68063b7770a735 has been pushed to the review server.

2015-08-03
It is available at http://review.typo3.org/4358

#2 - 2011-08-16 09:36 - Mr. Hudson

Patch set 2 of change |de7faf982f68efe15eb2fdaa5c¢68063b7770a735 has been pushed to the review server.
It is available at http://review.typo3.0rg/4358

#3 - 2011-08-16 10:05 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:237b0ac74d86ab207e1ee7c1715f7bf364cb2fa7.
